/*
Copyright (C) 2017-2018 Keziah Wesley

You can redistribute and/or modify this file under the terms of the
GNU Affero General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any
later version.

This file is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with this file. If not, see
<http://www.gnu.org/licenses/>.
*/
/* GENERATED FILE. CHANGES WILL BE OVERRIDDEN. 
This file is generated by Muddle code; it is included in the distribution for bootstrapping. */
enum {I_HALT=4,I_MUL=3,I_SUBB=2,I_SUB=1,I_GRTRB=0,};

void run (const uint8_t * p0, const uint8_t * p, object * bp, int sp) {
for (;;) {
TRACE(p0, p);
switch (*p) {
case I_HALT: {
const uint8_t * const oldp = p;
p += 1;
return;
break;
}
case I_MUL: {
int64_t x = GETFIX(bp[p[1]]);
int64_t y = GETFIX(bp[p[2]]);
object * _res = RESULT(3);
const uint8_t * const oldp = p;
p += 4;
*_res = (NEWFIX( x * y ));
break;
}
case I_SUBB: {
int64_t x = GETFIX(bp[p[1]]);
uint8_t rhs = p[2];
object * _res = RESULT(3);
const uint8_t * const oldp = p;
p += 4;
*_res = (NEWFIX( x - rhs ));
break;
}
case I_SUB: {
int64_t x = GETFIX(bp[p[1]]);
int64_t y = GETFIX(bp[p[2]]);
object * _res = RESULT(3);
const uint8_t * const oldp = p;
p += 4;
*_res = (NEWFIX( x - y ));
break;
}
case I_GRTRB: {
int64_t x = GETFIX(bp[p[1]]);
uint8_t rhs = p[2];
uint8_t invert = p[3];
int8_t offs = (int8_t)p[4];
const uint8_t * const oldp = p;
p += 5;
if (invert ^ (x > rhs)) JUMP(offs);
break;
}
default: assert(0 && "bad opcode");
}
}
}

int snprint_op_disasm(char ** buf, size_t outlen, const uint8_t ** p, size_t inlen)
{
switch (**p) {
case 4: 
if (inlen < 0) { return EBADOPARGS; };
*buf += snprintf(*buf, outlen, "<%s>\n", "HALT");
*p += 0;
return 0;
case 3: 
if (inlen < 3) { return EBADOPARGS; };
*buf += snprintf(*buf, outlen, "<%s fix%hhu fix%hhu %hhi>\n", "MUL", (*p)[1], (*p)[2], (*p)[3]);
*p += 3;
return 0;
case 2: 
if (inlen < 3) { return EBADOPARGS; };
*buf += snprintf(*buf, outlen, "<%s fix%hhu %hhu %hhi>\n", "SUBB", (*p)[1], (*p)[2], (*p)[3]);
*p += 3;
return 0;
case 1: 
if (inlen < 3) { return EBADOPARGS; };
*buf += snprintf(*buf, outlen, "<%s fix%hhu fix%hhu %hhi>\n", "SUB", (*p)[1], (*p)[2], (*p)[3]);
*p += 3;
return 0;
case 0: 
if (inlen < 4) { return EBADOPARGS; };
*buf += snprintf(*buf, outlen, "<%s fix%hhu %hhu %hhu %hhi>\n", "GRTRB", (*p)[1], (*p)[2], (*p)[3], (*p)[4]);
*p += 4;
return 0;
}
return EBADOPCODE;
}

